Page MenuHomePhabricator

Make https://git.wikimedia.org not redirect to Phabricator Diffusion
Open, Stalled, MediumPublic

Description

Currently https://git.wikimedia.org is a thing and unrelated to https://gitlab.wikimedia.org and also unrelated to https://gerrit.wikimedia.org

instead it links to https://phabricator.wikimedia.org/diffusion/

Do we still want to do that?

What else would we want to do with it, if anything?

Related Objects

StatusSubtypeAssignedTask
ResolvedQgil
ResolvedQgil
ResolvedQgil
Resolved RobLa-WMF
ResolvedQgil
Resolved demon
DeclinedNone
DeclinedNone
StalledDzahn
Resolved demon
Resolved demon
Resolved demon
Resolved demon
Resolved mmodell
Resolved mmodell
Resolved mmodell
ResolvedPaladox
Resolved demon
DuplicateNone
ResolvedQgil
Resolved mmodell
Resolved mmodell
Resolved mmodell
Resolved chasemp
Resolved mmodell
Resolved mmodell
Resolved mmodell
Resolved chasemp
Resolved mmodell
ResolvedQgil
DeclinedNone
InvalidQgil
ResolvedQgil
DeclinedNone
Resolvedyuvipanda
Invalid chasemp
Resolvedvalhallasw
Declinedvalhallasw
Resolvedvalhallasw
ResolvedLegoktm
ResolvedLegoktm
ResolvedLegoktm
InvalidLegoktm
DeclinedNone
DeclinedNone
DeclinedNone
InvalidQChris
ResolvedNone
DuplicateNone
DeclinedNone
DeclinedNone
Resolvedgreg
Resolvedgreg
Resolved demon
Resolvedgreg
DeclinedNone
Resolvedgreg
Invalidgreg
DeclinedNone
DeclinedNone
Declined mmodell
Resolvedgreg
Resolved demon
Invalid mmodell
DuplicateNone
Resolved mmodell
DeclinedNone
Resolved mmodell
Declinedgreg
Invalidgreg
DeclinedNone
ResolvedQgil
Invalid mmodell
Resolvedgreg
Resolvedgreg
Declinedgreg
DeclinedNone
Resolved chasemp
Resolved demon
Resolved chasemp
Resolved chasemp
Invalid chasemp
Resolved demon
ResolvedNemo_bis
Resolved demon
ResolvedPaladox
ResolvedKrenair
Resolved mmodell
InvalidNone
ResolvedDzahn

Event Timeline

LSobanski changed the task status from Open to Stalled.Nov 15 2022, 4:01 PM
LSobanski triaged this task as Low priority.
LSobanski subscribed.

Pending a decision from RelEng.

Do we know how many hits https://git.wikimedia.org gets?
I agree that Diffusion is not the place to link to.
https://gerrit.wikimedia.org/g/ or https://gitlab.wikimedia.org/explore/groups are potential targets.

It used to link to GitBlit prior to the "Lets migrate to Diffusion" plan, It could potentially wait till the gitlab migration and point there?

https://wikitech.wikimedia.org/wiki/Git.wikimedia.org

It used to link to GitBlit prior to the "Lets migrate to Diffusion" plan

Ack, makes sense. This means we should now point it to Gitiles (Gerrit Plugin) because that replaced Gitblit.

It could potentially wait till the gitlab migration and point there?

It can move from Gerrit to Gitlab when that time comes.

I don't think we should make anything wait for the day Gerrit is gone and/or Gitlab is declared the official place.

Do we know how many hits https://git.wikimedia.org gets?

I think the answer is no but also we know it's definitely not 0 and also not so high that it needs its own service.

So I guess the actual number wouldn't make a difference to our decision what to do with it.

(Note that https://www.mediawiki.org/wiki/Talk:Phabricator/Diffusion states that git.wikimedia.org was also used in some commit messages.)

Do we know how many hits https://git.wikimedia.org gets?

Screenshot from 2022-12-02 13-23-53.png (1×1 px, 196 KB)

I think we have to multiply the requests number by 128 since it's sampled. That's an entire year in the date range though.

So ~ 42k per year, or 115 requests per day.

Aklapper renamed this task from reconsider https://git.wikimedia.org link to Make https://git.wikimedia.org not redirect to Phabricator Diffusion.EditedSep 18 2023, 9:29 AM
Aklapper changed the task status from Stalled to Open.

Given the situation I'd propose a disambiguation page (similar to https://issues.apache.org/ ) as there is no single one Git repository.
No idea where to host though.

Wikimedia hosts two code repository systems, GitLab and Gerrit. Some projects may use Github for code hosting instead. To find the code location for a particular project, please check the relevant project website. 

* https://gitlab.wikimedia.org/explore/groups
* https://gerrit.wikimedia.org/g/

This would break some rewrite rules in puppet/modules/profile/manifests/phabricator/main.pp and that is fine after many years of git.wikimedia.org not hosting content itself.

Given the situation I'd propose a disambiguation page

+1 for a brief static disambiguation page. If that's creating too much busywork, I'd vote for just changing the redirect to https://gitlab.wikimedia.org/explore/groups and call it good.

Given the situation I'd propose a disambiguation page (similar to https://issues.apache.org/ ) as there is no single one Git repository.
No idea where to host though.

Possibly we can put that into miscweb k8s.

https://git.wikimedia.org/ was once used as a repository browser for Gerrit which was powered by https://www.gitblit.com/ . in 2014 or so, we had a plan to migrate code review from Gerrit to Phabricator Differential. Given Phabricator has its own code browsing system (Diffusion), we went to phase out Gitblit (Gitblit-Deprecate). Phabricator pulls the Gerrit repositories and exposes them in Diffusion and I think we had a manually maintained mapping between Gerrit repository names (ex mediawiki/core) and Diffusion code names (ex: rMW).

I think we went through several code browser (I am pretty sure we had gitweb cgi at some point) and some wanted a canonical, long standing URL to share regardless of the code browser or review system being used. That is why we got git.wikimedia.org in the first place and given that was meant to be canonical we have some redirect/URL mapping in place between the old Gitblit URL toward the new Diffusion URL. I think the effort was inconclusive since:

  • the names mapping was manually maintained
  • we have never reached a full 1/1 mapping of all URLs (branches, commits, direct files etc)

Given the git.wikimedia.org service had so many gaps, its usage have been replaced by links to Phabricator Diffusion ( T139089 ).

git.wikimedia.org was an attempt to be a tool agnostic canonical URL. That spanned a couple years (2015/2016) and eventually its interest has fanned out. There is barely anything using it anymore: I count 400 hits over the last 30 days and 700 hits from a single IP in Alibaba Cloud with a UA of Chrome v61.

My recommendation is to phase out https://git.wikimedia.org/ entirely, people have long learned to not rely on it.

...
My recommendation is to phase out https://git.wikimedia.org/ entirely, people have long learned to not rely on it.

I'd prefer this option as well. But there should not be a problem to add this to miscweb as well.

Change 1006979 had a related patch set uploaded (by Dzahn; author: Dzahn):

[operations/puppet@production] cache::text: remove git.wikimedia.org

https://gerrit.wikimedia.org/r/1006979

Change 1006982 had a related patch set uploaded (by Dzahn; author: Dzahn):

[operations/puppet@production] phabricator: remove git.wikimedia.org vhost, rewrites and tests

https://gerrit.wikimedia.org/r/1006982

@hashar @Jelto Fair enough, I am not opposed to deleting it all. It would mean though that all of this goes away. See the rewrite rules here:

https://gerrit.wikimedia.org/r/c/operations/puppet/+/1006982/1/modules/phabricator/templates/gitblit_vhost.conf.erb

More generally I feel we should be using descriptors not software names for sites (so tasks.wikimedia.org not phabricator.… / phorge.…, monitoring.… not logstash.…, etc.), so when the software changes / gets renamed our landing site stays the same, but I fear no-one else agrees. Ah well.

we should be using descriptors not software names for sites (so tasks.wikimedia.org not phabricator.… / phorge.… .but I fear no-one else agrees.

I agree with this. At least when setting up new things. Renaming something like phabricator.wikimedia.org would be a big deal but before we ever call that phorge.wikimedia.org it would definitely be better to use tasks.wikimedia.org.

git.wikimedia.org is also better than gitlab.wikimedia.org for sure. It's just that once you have introduced a name you have to keep all those rewrite rules and the old virtual hosts around forever so setup becomes more complex rather than simpler.

Fair enough, though as an example, just by substracting "User:MarkAHershberger/sandbox" and "MediaWiki 1.24/Extension branchpoints" it's under 500 instead of 1500 right away.

More generally I feel we should be using descriptors not software names for sites (so tasks.wikimedia.org not phabricator.… / phorge.…, monitoring.… not logstash.…, etc.), so when the software changes / gets renamed our landing site stays the same, but I fear no-one else agrees. Ah well.

But that would break links and history of old systems once we migrate to a newer service. For example if we would have hosted bugzilla under tasks.wikimedia.org and we also want to host the current task system phabricator under tasks.wikimedia.org there would be no way to preserve history and links. I think using the actual software name (like gitlab, phabricator, gerrit) make sense mostly and allows us to keep history.

The above may include links generated from a re-usable template.

(I tried to get a sense of more specific ways in which links are made via Global Seach, but currently unavailable, T358541.)

I can not tell the relevance of this links and if that's a lot or not. But from going over a few of this search results most links are dead and just redirecting to https://phabricator.wikimedia.org/diffusion/?

Change 1006979 abandoned by Dzahn:

[operations/puppet@production] cache::text: remove git.wikimedia.org

Reason:

there has been more feedback to keep it than to delete it so far and discussion still coming

https://gerrit.wikimedia.org/r/1006979

1,500+ outgoing links on www.mediawiki.org: https://www.mediawiki.org/wiki/Special:LinkSearch?target=git.wikimedia.org

391 of from https://www.mediawiki.org/wiki/User:MarkAHershberger/sandbox which is from 2013
658 in https://www.mediawiki.org/wiki/MediaWiki_1.24/Extension_branchpoints which is from 2014

The links found by Timo all comes from the few months the service has been active a decade ago and they are really obsolete by now (see also my previous comment T323073#9452341 ). The links are already broken anyway since they now redirect to https://phabricator.wikimedia.org/diffusion/

If someone is looking for an approval from that era / release engineering, here it is: please decommission git.wikimedia.org with no redirections left behind.

LSobanski raised the priority of this task from Low to Medium.Mar 12 2024, 3:13 PM
Dzahn changed the task status from Open to Stalled.Fri, May 10, 8:08 PM